/* A Bison parser, made from ../../../../tools/qfcc/source/qc-parse.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	ASX	257
# define	PAS	258
# define	OR	259
# define	AND	260
# define	EQ	261
# define	NE	262
# define	LE	263
# define	GE	264
# define	LT	265
# define	GT	266
# define	SHL	267
# define	SHR	268
# define	UNARY	269
# define	INCOP	270
# define	HYPERUNARY	271
# define	CLASS_NAME	272
# define	NAME	273
# define	STRING_VAL	274
# define	INT_VAL	275
# define	FLOAT_VAL	276
# define	VECTOR_VAL	277
# define	QUATERNION_VAL	278
# define	LOCAL	279
# define	RETURN	280
# define	WHILE	281
# define	DO	282
# define	IF	283
# define	ELSE	284
# define	FOR	285
# define	BREAK	286
# define	CONTINUE	287
# define	ELLIPSIS	288
# define	NIL	289
# define	IFBE	290
# define	IFB	291
# define	IFAE	292
# define	IFA	293
# define	SWITCH	294
# define	CASE	295
# define	DEFAULT	296
# define	STRUCT	297
# define	UNION	298
# define	ENUM	299
# define	TYPEDEF	300
# define	SUPER	301
# define	SELF	302
# define	THIS	303
# define	ARGS	304
# define	ARGC	305
# define	ARGV	306
# define	EXTERN	307
# define	STATIC	308
# define	SYSTEM	309
# define	SIZEOF	310
# define	ELE_START	311
# define	TYPE	312
# define	CLASS	313
# define	DEFS	314
# define	ENCODE	315
# define	END	316
# define	IMPLEMENTATION	317
# define	INTERFACE	318
# define	PRIVATE	319
# define	PROTECTED	320
# define	PROTOCOL	321
# define	PUBLIC	322
# define	SELECTOR	323

#line 1 "../../../../tools/qfcc/source/qc-parse.y"

/*
	qc-parse.y

	parser for quakec

	Copyright (C) 2001 Bill Currie <bill@taniwha.org>

	Author: Bill Currie <bill@taniwha.org>
	Date: 2001/06/12

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

	See the GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place - Suite 330
		Boston, MA  02111-1307, USA

*/
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

static __attribute__ ((unused)) const char rcsid[] = 
	"$Id: qc-parse.y,v 1.176 2003/03/10 21:23:05 taniwha Exp $";

#ifdef HAVE_STRING_H
# include <string.h>
#endif
#ifdef HAVE_STRINGS_H
# include <strings.h>
#endif
#include <stdlib.h>

#include <QF/hash.h>
#include <QF/sys.h>

#include "class.h"
#include "debug.h"
#include "def.h"
#include "emit.h"
#include "expr.h"
#include "function.h"
#include "immediate.h"
#include "method.h"
#include "options.h"
#include "qfcc.h"
#include "reloc.h"
#include "struct.h"
#include "switch.h"
#include "type.h"

#define YYDEBUG 1
#define YYERROR_VERBOSE 1
#undef YYERROR_VERBOSE

extern char *yytext;

static void
yyerror (const char *s)
{
#ifdef YYERROR_VERBOSE
	error (0, "%s %s\n", yytext, s);
#else
	error (0, "%s before %s", s, yytext);
#endif
}

static void
parse_error (void)
{
	error (0, "parse error before %s", yytext);
}

#define PARSE_ERROR do { parse_error (); YYERROR; } while (0)

int yylex (void);

hashtab_t *save_local_inits (scope_t *scope);
hashtab_t *merge_local_inits (hashtab_t *dl_1, hashtab_t *dl_2);
void restore_local_inits (hashtab_t *def_list);
void free_local_inits (hashtab_t *def_list);

expr_t *argc_expr (void);
expr_t *argv_expr (void);


#line 100 "../../../../tools/qfcc/source/qc-parse.y"
#ifndef YYSTYPE
typedef union {
	int			op;
	struct def_s *def;
	struct hashtab_s	*def_list;
	type_t		*type;
	expr_t		*expr;
	int			integer_val;
	float		float_val;
	const char *string_val;
	float		vector_val[3];
	float		quaternion_val[4];
	struct function_s *function;
	struct switch_block_s	*switch_block;
	struct param_s	*param;
	struct method_s	*method;
	struct class_s	*class;
	struct category_s *category;
	struct class_type_s	*class_type;
	struct protocol_s *protocol;
	struct keywordarg_s *keywordarg;
	struct methodlist_s *methodlist;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#line 179 "../../../../tools/qfcc/source/qc-parse.y"


function_t *current_func;
param_t *current_params;
expr_t	*current_init;
class_type_t *current_class;
expr_t	*local_expr;
expr_t	*break_label;
expr_t	*continue_label;
switch_block_t *switch_block;
type_t	*struct_type;
visibility_t current_visibility;
type_t	*current_ivars;
scope_t *current_scope;
storage_class_t current_storage;

int      element_flag;

#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		555
#define	YYFLAG		-32768
#define	YYNTBASE	94

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 323 ? yytranslate[x] : 230)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    91,     2,    90,     2,    25,    22,     2,
      30,    87,    20,    18,    88,    19,    29,    21,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     7,    84,
       2,     3,     2,     6,    93,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    31,     2,    89,    24,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    85,    23,    86,    92,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     4,     5,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    26,
      27,    28,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     2,     7,    10,    11,    15,    16,    21,
      26,    27,    35,    36,    44,    50,    54,    62,    63,    67,
      68,    72,    74,    76,    78,    79,    83,    88,    89,    93,
      95,    99,   101,   105,   108,   110,   113,   117,   120,   122,
     124,   126,   130,   136,   140,   144,   147,   149,   153,   156,
     160,   163,   164,   169,   171,   173,   174,   179,   181,   184,
     186,   187,   188,   191,   194,   195,   201,   205,   206,   213,
     214,   215,   222,   223,   226,   228,   232,   233,   234,   240,
     242,   243,   245,   246,   247,   248,   253,   254,   257,   259,
     261,   265,   268,   271,   274,   278,   281,   282,   292,   301,
     311,   312,   318,   325,   326,   336,   349,   352,   353,   354,
     355,   356,   358,   359,   361,   364,   367,   370,   373,   376,
     379,   384,   386,   388,   390,   392,   394,   396,   398,   402,
     407,   412,   416,   419,   422,   424,   426,   431,   433,   437,
     441,   447,   451,   455,   459,   463,   467,   471,   475,   479,
     483,   487,   491,   495,   499,   503,   507,   511,   515,   519,
     520,   522,   524,   528,   530,   532,   534,   536,   538,   540,
     542,   545,   547,   549,   551,   552,   555,   557,   559,   563,
     567,   569,   571,   573,   575,   579,   583,   588,   593,   595,
     596,   597,   598,   599,   612,   613,   614,   622,   623,   624,
     625,   626,   639,   640,   641,   649,   650,   651,   659,   660,
     661,   669,   672,   673,   674,   682,   685,   688,   689,   690,
     698,   699,   703,   704,   707,   711,   713,   715,   717,   719,
     720,   724,   725,   729,   731,   732,   737,   739,   740,   741,
     750,   757,   758,   759,   768,   775,   776,   778,   779,   782,
     785,   789,   793,   798,   800,   806,   809,   810,   813,   816,
     821,   823,   825,   828,   830,   832,   834,   836,   838,   840,
     842,   844,   846,   848,   850,   852,   854,   856,   858,   860,
     862,   864,   866,   868,   870,   877,   881,   887,   890,   892,
     897,   902,   907,   909,   914,   916,   918,   920,   922,   924,
     926,   929,   933,   936,   938,   940,   942,   945,   948,   950,
     953
};
static const short yyrhs[] =
{
      -1,     0,    94,    95,    96,    84,     0,    94,   159,     0,
       0,   110,    97,   120,     0,     0,   104,   110,    98,   120,
       0,   104,    85,   101,    86,     0,     0,    57,    33,    99,
       3,    85,   105,    86,     0,     0,    58,    33,   100,     3,
      85,   105,    86,     0,    59,    85,   108,   136,    86,     0,
      60,   110,    33,     0,    60,    59,    85,   108,   136,    86,
      33,     0,     0,   101,   102,    84,     0,     0,   110,   103,
     120,     0,    67,     0,    68,     0,    69,     0,     0,   105,
     106,    84,     0,    74,    30,    33,    87,     0,     0,   110,
     107,   117,     0,   109,     0,   108,    88,   109,     0,    33,
       0,    33,     3,   154,     0,    29,   110,     0,   111,     0,
     111,   113,     0,    30,   110,    87,     0,   111,   116,     0,
     112,     0,    72,     0,    32,     0,    30,   114,    87,     0,
      30,   114,    88,    48,    87,     0,    30,    48,    87,     0,
      30,    72,    87,     0,    30,    87,     0,   115,     0,   114,
      88,   115,     0,   110,    33,     0,    31,   157,    89,     0,
      31,    89,     0,     0,   117,    88,   118,   119,     0,   119,
       0,    33,     0,     0,   120,    88,   121,   122,     0,   122,
       0,   123,   124,     0,    33,     0,     0,     0,   125,   126,
       0,     3,   154,     0,     0,     3,    71,   127,   131,    86,
       0,     3,    90,   157,     0,     0,     3,   129,   128,   137,
     139,   138,     0,     0,     0,    31,   157,    88,   130,   123,
      89,     0,     0,   132,   136,     0,   133,     0,   132,    88,
     133,     0,     0,     0,    85,   134,   131,   135,    86,     0,
     154,     0,     0,    88,     0,     0,     0,     0,    85,   140,
     141,    86,     0,     0,   141,   142,     0,    84,     0,   139,
       0,    40,   154,    84,     0,    40,    84,     0,    46,    84,
       0,    47,    84,     0,    55,   154,     7,     0,    56,     7,
       0,     0,    54,   146,   148,    30,   154,    87,   143,   149,
     139,     0,    41,   146,   147,    30,   154,    87,   149,   142,
       0,    42,   146,   147,   142,    41,    30,   154,    87,    84,
       0,     0,    39,   110,   144,   120,    84,     0,    43,    30,
     154,    87,   149,   142,     0,     0,    43,    30,   154,    87,
     149,   142,    44,   145,   142,     0,    45,   146,   147,    30,
     150,    84,   150,    84,   150,    87,   149,   142,     0,   154,
      84,     0,     0,     0,     0,     0,   154,     0,     0,   152,
       0,    18,   153,     0,    19,   153,     0,    91,   153,     0,
      92,   153,     0,    22,   153,     0,    70,   151,     0,    70,
      30,   110,    87,     0,    33,     0,    64,     0,    65,     0,
      66,     0,    62,     0,    63,     0,   157,     0,    30,   154,
      87,     0,   152,    30,   155,    87,     0,   152,    31,   154,
      89,     0,   152,    29,   152,     0,    27,   152,     0,   152,
      27,     0,   220,     0,   151,     0,    30,   110,    87,   153,
       0,   153,     0,   154,     3,   154,     0,   154,     4,   154,
       0,   154,     6,   154,     7,   154,     0,   154,     9,   154,
       0,   154,     8,   154,     0,   154,    10,   154,     0,   154,
      11,   154,     0,   154,    12,   154,     0,   154,    13,   154,
       0,   154,    14,   154,     0,   154,    15,   154,     0,   154,
      16,   154,     0,   154,    17,   154,     0,   154,    18,   154,
       0,   154,    19,   154,     0,   154,    20,   154,     0,   154,
      21,   154,     0,   154,    22,   154,     0,   154,    23,   154,
       0,   154,    24,   154,     0,   154,    25,   154,     0,     0,
     156,     0,   154,     0,   156,    88,   154,     0,    36,     0,
     158,     0,    37,     0,    38,     0,    35,     0,    49,     0,
      34,     0,   158,    34,     0,   171,     0,   162,     0,   190,
       0,     0,   160,   204,     0,    76,     0,    33,     0,   161,
      88,    33,     0,    73,   161,    84,     0,    33,     0,    32,
       0,   163,     0,   163,     0,   164,     7,   164,     0,   165,
       7,   164,     0,   163,    30,   163,    87,     0,   163,    30,
     163,    87,     0,   163,     0,     0,     0,     0,     0,    78,
     165,   193,   172,    85,   173,   194,    86,   174,   209,   175,
      76,     0,     0,     0,    78,   165,   193,   176,   209,   177,
      76,     0,     0,     0,     0,     0,    78,   167,   193,   178,
      85,   179,   194,    86,   180,   209,   181,    76,     0,     0,
       0,    78,   167,   193,   182,   209,   183,    76,     0,     0,
       0,    78,   169,   193,   184,   209,   185,    76,     0,     0,
       0,    77,   164,   186,    85,   187,   194,    86,     0,    77,
     164,     0,     0,     0,    77,   166,   188,    85,   189,   194,
      86,     0,    77,   166,     0,    77,   168,     0,     0,     0,
      81,   170,   193,   191,   209,   192,    76,     0,     0,    14,
     161,    15,     0,     0,   195,   196,     0,   196,   197,   198,
       0,   198,     0,    79,     0,    80,     0,    82,     0,     0,
     198,   199,    84,     0,     0,   110,   200,   201,     0,   203,
       0,     0,   201,    88,   202,   203,     0,    33,     0,     0,
       0,    18,   213,   205,   129,   206,   137,   139,   138,     0,
      18,   213,     3,    90,   157,    84,     0,     0,     0,    19,
     213,   207,   129,   208,   137,   139,   138,     0,    19,   213,
       3,    90,   157,    84,     0,     0,   210,     0,     0,   211,
     212,     0,   210,   212,     0,    18,   213,    84,     0,    19,
     213,    84,     0,    30,   110,    87,   215,     0,   215,     0,
      30,   110,    87,   216,   214,     0,   216,   214,     0,     0,
      88,    48,     0,    88,   114,     0,    88,   114,    88,    48,
       0,   217,     0,   219,     0,   216,   219,     0,   163,     0,
      72,     0,   218,     0,    39,     0,    40,     0,    41,     0,
      42,     0,    43,     0,    44,     0,    45,     0,    46,     0,
      47,     0,    54,     0,    55,     0,    56,     0,    49,     0,
      57,     0,    58,     0,    59,     0,    60,     0,    61,     0,
     217,     7,    30,   110,    87,    33,     0,   217,     7,    33,
       0,     7,    30,   110,    87,    33,     0,     7,    33,     0,
     221,     0,    83,    30,   226,    87,     0,    81,    30,   163,
      87,     0,    75,    30,   110,    87,     0,   229,     0,    31,
     222,   223,    89,     0,   154,     0,    32,     0,    61,     0,
     217,     0,   224,     0,   225,     0,   224,   225,     0,   217,
       7,   156,     0,     7,   156,     0,   217,     0,   227,     0,
     228,     0,   227,   228,     0,   217,     7,     0,     7,     0,
      93,    34,     0,   229,    93,    34,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   202,   203,   203,   204,   208,   208,   209,   209,   210,
     211,   211,   213,   213,   215,   217,   219,   227,   228,   232,
     232,   236,   237,   238,   242,   243,   244,   257,   257,   261,
     262,   274,   275,   291,   292,   293,   301,   302,   309,   313,
     314,   326,   327,   333,   334,   340,   344,   345,   353,   357,
     366,   370,   370,   371,   375,   379,   379,   380,   384,   393,
     408,   409,   409,   414,   438,   438,   443,   447,   447,   462,
     466,   466,   480,   484,   491,   495,   502,   502,   502,   515,
     522,   523,   527,   547,   554,   554,   578,   582,   589,   590,
     591,   595,   599,   607,   615,   619,   623,   623,   635,   661,
     675,   675,   686,   703,   703,   742,   766,   773,   781,   789,
     797,   804,   805,   812,   813,   814,   815,   816,   817,   818,
     819,   823,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,   834,   835,   836,   840,   841,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   854,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,   865,   866,   870,
     871,   875,   876,   884,   885,   886,   887,   888,   889,   893,
     894,   901,   902,   903,   904,   904,   905,   916,   921,   929,
     938,   939,   943,   954,   965,   974,   982,   993,  1004,  1017,
    1017,  1017,  1017,  1017,  1023,  1023,  1023,  1027,  1027,  1027,
    1027,  1027,  1033,  1033,  1033,  1037,  1037,  1037,  1041,  1041,
    1041,  1044,  1045,  1045,  1045,  1048,  1049,  1053,  1053,  1053,
    1060,  1061,  1065,  1065,  1082,  1083,  1087,  1088,  1089,  1093,
    1094,  1098,  1098,  1102,  1103,  1103,  1107,  1114,  1114,  1114,
    1136,  1144,  1144,  1144,  1166,  1177,  1178,  1182,  1182,  1187,
    1195,  1201,  1211,  1213,  1215,  1217,  1222,  1223,  1224,  1225,
    1233,  1237,  1238,  1242,  1243,  1244,  1248,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,
    1262,  1263,  1264,  1265,  1269,  1271,  1273,  1275,  1280,  1281,
    1282,  1283,  1284,  1288,  1292,  1293,  1294,  1298,  1299,  1303,
    1304,  1312,  1313,  1317,  1318,  1322,  1323,  1331,  1332,  1336,
    1337
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "'='", "ASX", "PAS", "'?'", "':'", "OR", 
  "AND", "EQ", "NE", "LE", "GE", "LT", "GT", "SHL", "SHR", "'+'", "'-'", 
  "'*'", "'/'", "'&'", "'|'", "'^'", "'%'", "UNARY", "INCOP", 
  "HYPERUNARY", "'.'", "'('", "'['", "CLASS_NAME", "NAME", "STRING_VAL", 
  "INT_VAL", "FLOAT_VAL", "VECTOR_VAL", "QUATERNION_VAL", "LOCAL", 
  "RETURN", "WHILE", "DO", "IF", "ELSE", "FOR", "BREAK", "CONTINUE", 
  "ELLIPSIS", "NIL", "IFBE", "IFB", "IFAE", "IFA", "SWITCH", "CASE", 
  "DEFAULT", "STRUCT", "UNION", "ENUM", "TYPEDEF", "SUPER", "SELF", 
  "THIS", "ARGS", "ARGC", "ARGV", "EXTERN", "STATIC", "SYSTEM", "SIZEOF", 
  "ELE_START", "TYPE", "CLASS", "DEFS", "ENCODE", "END", "IMPLEMENTATION", 
  "INTERFACE", "PRIVATE", "PROTECTED", "PROTOCOL", "PUBLIC", "SELECTOR", 
  "';'", "'{'", "'}'", "')'", "','", "']'", "'#'", "'!'", "'~'", "'@'", 
  "defs", "@1", "def", "@2", "@3", "@4", "@5", "simple_defs", 
  "simple_def", "@6", "storage_class", "struct_defs", "struct_def", "@7", 
  "enum_list", "enum", "type", "non_field_type", "type_name", 
  "function_decl", "param_list", "param", "array_decl", "struct_def_list", 
  "@8", "struct_def_item", "def_list", "@9", "def_item", "def_name", 
  "opt_initializer", "@10", "var_initializer", "@11", "@12", 
  "opt_state_expr", "@13", "element_list", "element_list1", "element", 
  "@14", "@15", "opt_comma", "begin_function", "end_function", 
  "statement_block", "@16", "statements", "statement", "@17", "@18", 
  "@19", "break_label", "continue_label", "switch_block", "save_inits", 
  "opt_expr", "unary_expr", "primary", "cast_expr", "expr", 
  "opt_arg_list", "arg_list", "const", "string_val", "obj_def", "@20", 
  "identifier_list", "classdecl", "maybe_class", "class_name", 
  "new_class_name", "class_with_super", "new_class_with_super", 
  "category_name", "new_category_name", "protocol_name", "classdef", 
  "@21", "@22", "@23", "@24", "@25", "@26", "@27", "@28", "@29", "@30", 
  "@31", "@32", "@33", "@34", "@35", "@36", "@37", "@38", "protocoldef", 
  "@39", "@40", "protocolrefs", "ivar_decl_list", "@41", 
  "ivar_decl_list_2", "visibility_spec", "ivar_decls", "ivar_decl", "@42", 
  "ivars", "@43", "ivar_declarator", "methoddef", "@44", "@45", "@46", 
  "@47", "methodprotolist", "methodprotolist2", "@48", "methodproto", 
  "methoddecl", "optparmlist", "unaryselector", "keywordselector", 
  "selector", "reserved_word", "keyworddecl", "obj_expr", 
  "obj_messageexpr", "receiver", "messageargs", "keywordarglist", 
  "keywordarg", "selectorarg", "keywordnamelist", "keywordname", 
  "obj_string", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    94,    95,    94,    94,    97,    96,    98,    96,    96,
      99,    96,   100,    96,    96,    96,    96,   101,   101,   103,
     102,   104,   104,   104,   105,   105,   105,   107,   106,   108,
     108,   109,   109,   110,   110,   110,   111,   111,   111,   112,
     112,   113,   113,   113,   113,   113,   114,   114,   115,   116,
     116,   118,   117,   117,   119,   121,   120,   120,   122,   123,
     124,   125,   124,   126,   127,   126,   126,   128,   126,   129,
     130,   129,   131,   131,   132,   132,   134,   135,   133,   133,
     136,   136,   137,   138,   140,   139,   141,   141,   142,   142,
     142,   142,   142,   142,   142,   142,   143,   142,   142,   142,
     144,   142,   142,   145,   142,   142,   142,   146,   147,   148,
     149,   150,   150,   151,   151,   151,   151,   151,   151,   151,
     151,   152,   152,   152,   152,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   153,   153,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   154,   154,   154,   154,   154,   155,
     155,   156,   156,   157,   157,   157,   157,   157,   157,   158,
     158,   159,   159,   159,   160,   159,   159,   161,   161,   162,
     163,   163,   164,   165,   166,   167,   168,   169,   170,   172,
     173,   174,   175,   171,   176,   177,   171,   178,   179,   180,
     181,   171,   182,   183,   171,   184,   185,   171,   186,   187,
     171,   171,   188,   189,   171,   171,   171,   191,   192,   190,
     193,   193,   195,   194,   196,   196,   197,   197,   197,   198,
     198,   200,   199,   201,   202,   201,   203,   205,   206,   204,
     204,   207,   208,   204,   204,   209,   209,   211,   210,   210,
     212,   212,   213,   213,   213,   213,   214,   214,   214,   214,
     215,   216,   216,   217,   217,   217,   218,   218,   218,   218,
     218,   218,   218,   218,   218,   218,   218,   218,   218,   218,
     218,   218,   218,   218,   219,   219,   219,   219,   220,   220,
     220,   220,   220,   221,   222,   222,   222,   223,   223,   224,
     224,   225,   225,   226,   226,   227,   227,   228,   228,   229,
     229
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     0,     4,     2,     0,     3,     0,     4,     4,
       0,     7,     0,     7,     5,     3,     7,     0,     3,     0,
       3,     1,     1,     1,     0,     3,     4,     0,     3,     1,
       3,     1,     3,     2,     1,     2,     3,     2,     1,     1,
       1,     3,     5,     3,     3,     2,     1,     3,     2,     3,
       2,     0,     4,     1,     1,     0,     4,     1,     2,     1,
       0,     0,     2,     2,     0,     5,     3,     0,     6,     0,
       0,     6,     0,     2,     1,     3,     0,     0,     5,     1,
       0,     1,     0,     0,     0,     4,     0,     2,     1,     1,
       3,     2,     2,     2,     3,     2,     0,     9,     8,     9,
       0,     5,     6,     0,     9,    12,     2,     0,     0,     0,
       0,     1,     0,     1,     2,     2,     2,     2,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     1,     3,     4,
       4,     3,     2,     2,     1,     1,     4,     1,     3,     3,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     0,     2,     1,     1,     3,     3,
       1,     1,     1,     1,     3,     3,     4,     4,     1,     0,
       0,     0,     0,    12,     0,     0,     7,     0,     0,     0,
       0,    12,     0,     0,     7,     0,     0,     7,     0,     0,
       7,     2,     0,     0,     7,     2,     2,     0,     0,     7,
       0,     3,     0,     2,     3,     1,     1,     1,     1,     0,
       3,     0,     3,     1,     0,     4,     1,     0,     0,     8,
       6,     0,     0,     8,     6,     0,     1,     0,     2,     2,
       3,     3,     4,     1,     5,     2,     0,     2,     2,     4,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     3,     5,     2,     1,     4,
       4,     4,     1,     4,     1,     1,     1,     1,     1,     1,
       2,     3,     2,     1,     1,     1,     2,     2,     1,     2,
       3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,     2,     0,   176,     0,     0,     0,     0,     4,     0,
     172,   171,   173,   177,     0,   181,   180,   182,   211,   215,
     216,   183,   220,   220,   220,   188,   220,     0,     0,    40,
       0,     0,     0,     0,    21,    22,    23,    39,     0,     0,
       5,    34,    38,     0,     0,   175,   179,     0,     0,     0,
       0,     0,     0,     0,     0,   194,   202,   205,   217,    33,
       0,    10,    12,     0,     0,     0,     3,    17,     7,     0,
       0,     0,    35,    37,     0,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   278,   275,   276,   277,   279,
     280,   281,   282,   283,   264,   263,   237,   253,   256,   260,
     265,   261,   241,   178,     0,   182,   184,   209,   213,     0,
     185,     0,     0,   247,     0,   247,   247,   247,    36,     0,
       0,    31,    80,    29,     0,    15,     0,     0,    59,     6,
      57,    60,     0,    39,    45,     0,     0,    46,   169,   167,
     163,   165,   166,   168,    50,     0,   164,     0,   287,     0,
       0,    69,     0,   255,     0,   262,     0,     0,    69,   186,
     222,   222,   187,   221,   190,   195,   246,     0,   198,   203,
     206,   218,     0,     0,     0,    81,     0,    80,     9,     0,
      19,     8,    55,    58,     0,    43,    44,    48,    41,     0,
      49,   170,     0,     0,     0,     0,   238,   257,   258,     0,
     285,     0,   242,     0,   229,     0,   222,     0,     0,     0,
     249,   248,   222,     0,     0,     0,    24,    24,     0,     0,
       0,     0,     0,     0,   121,   125,   126,   122,   123,   124,
       0,     0,     0,     0,     0,     0,     0,   135,   113,   137,
      32,   127,   134,   288,   292,    30,    14,     0,    18,     0,
       0,    69,    62,     0,    47,     0,   252,   256,     0,     0,
      82,     0,     0,     0,    82,   210,   223,   225,   214,     0,
     196,     0,     0,     0,   204,   207,   219,     0,     0,     0,
     114,   115,   118,     0,   132,     0,     0,     0,   295,   296,
     294,     0,     0,   119,     0,     0,     0,   116,   117,   309,
     133,     0,   159,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,    56,     0,
      64,     0,    67,    63,    42,   286,   254,   240,    70,     0,
     259,     0,   244,     0,   226,   227,   228,   229,   231,     0,
     191,   250,   251,   199,     0,    11,     0,    27,    13,     0,
       0,   128,     0,   297,     0,   298,   299,     0,     0,     0,
     308,   303,     0,   304,   305,   131,   161,     0,   160,     0,
     138,   139,     0,   142,   141,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   310,    16,   127,    72,    66,    82,     0,    84,    83,
     284,    83,   224,     0,   230,   247,   247,     0,    25,     0,
      36,   136,   302,     0,   293,     0,   300,   120,   291,   290,
     307,   289,     0,   306,   129,     0,   130,     0,    76,     0,
      80,    74,    79,     0,     0,    86,   239,   243,   236,   232,
     233,   192,   200,    26,    54,    28,    53,   301,   162,   140,
      72,    65,    81,    73,    83,    71,     0,   234,     0,     0,
      51,    77,    75,    68,     0,     0,   107,   107,     0,   107,
       0,     0,   107,     0,     0,    88,    85,    89,    87,     0,
       0,   193,   201,     0,     0,   100,    91,     0,   108,   108,
       0,   108,    92,    93,   109,     0,    95,   106,   235,    52,
      78,     0,    90,     0,     0,     0,     0,     0,    94,     0,
       0,     0,   110,   112,     0,   101,     0,     0,     0,     0,
     111,     0,   110,     0,   102,   112,    96,     0,     0,   103,
       0,   110,    98,     0,     0,   112,     0,    99,   104,     0,
      97,   110,     0,   105,     0,     0
};

static const short yydefgoto[] =
{
       1,     7,    38,    69,   127,   119,   120,   126,   179,   249,
      39,   278,   356,   419,   122,   123,   135,    41,    42,    72,
     136,   137,    73,   455,   493,   456,   129,   250,   130,   131,
     183,   184,   252,   404,   406,   196,   407,   439,   440,   441,
     460,   494,   176,   339,   446,   487,   445,   466,   488,   541,
     511,   544,   498,   513,   517,   528,   529,   237,   238,   239,
     489,   377,   378,   241,   146,     8,     9,    14,    10,    95,
      18,    22,    19,    23,    20,    24,    26,    11,   112,   206,
     415,   468,   113,   207,   114,   212,   416,   469,   115,   213,
     116,   214,    50,   160,    51,   161,    12,   117,   215,    55,
     203,   204,   266,   347,   267,   349,   413,   449,   490,   450,
      45,   151,   260,   158,   264,   165,   166,   167,   210,    96,
     153,    97,    98,    99,   100,   101,   242,   243,   291,   364,
     365,   366,   372,   373,   374,   244
};

static const short yypact[] =
{
  -32768,    40,    -8,-32768,   133,   133,   133,   261,-32768,   156,
  -32768,-32768,-32768,-32768,    -9,-32768,-32768,     6,    26,    27,
  -32768,    46,    60,   112,   112,-32768,   112,    16,    16,-32768,
     138,   160,   167,     5,-32768,-32768,-32768,-32768,   173,   106,
  -32768,   218,-32768,  1230,  1230,-32768,-32768,   225,   133,   133,
     183,   185,   133,   133,    -8,   190,   192,-32768,-32768,-32768,
     172,-32768,-32768,   246,   195,   250,-32768,-32768,-32768,   251,
     174,   161,-32768,-32768,    11,    16,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   283,-32768,   484,   281,
  -32768,-32768,   289,-32768,   211,-32768,-32768,-32768,-32768,   213,
  -32768,    32,   220,   231,   223,   231,   231,   231,-32768,   306,
     307,   308,   224,-32768,   246,-32768,    -1,   251,-32768,   227,
  -32768,   313,   230,   236,-32768,   291,   166,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,   238,   292,    16,-32768,   244,
     235,   301,   234,-32768,   281,-32768,   104,   268,   301,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   237,   237,-32768,-32768,
  -32768,-32768,   249,   275,  1076,   246,   280,   224,-32768,   277,
  -32768,   227,-32768,-32768,   365,-32768,-32768,-32768,-32768,   265,
  -32768,-32768,   282,  1271,   145,   145,-32768,-32768,   285,    16,
  -32768,   145,-32768,   284,-32768,   316,-32768,   295,  1230,  1230,
  -32768,-32768,-32768,   327,   328,   330,   334,   334,  1076,  1076,
    1076,  1166,   740,   807,-32768,-32768,-32768,-32768,-32768,-32768,
    1143,   379,   380,   381,  1076,  1076,   378,-32768,    53,-32768,
    1466,-32768,-32768,-32768,   320,-32768,-32768,   331,-32768,   251,
     251,   874,-32768,   353,-32768,   409,-32768,   484,   377,   326,
  -32768,   335,   375,   402,-32768,-32768,   134,    16,-32768,   401,
  -32768,   404,   405,   406,-32768,-32768,-32768,   463,    98,   179,
  -32768,-32768,-32768,  1076,    53,   740,   403,   217,-32768,-32768,
    1466,  1312,   740,-32768,    16,   133,  1353,-32768,-32768,-32768,
  -32768,  1166,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,  1076,
    1076,  1076,  1076,  1076,  1076,   431,   461,   227,-32768,   807,
  -32768,   145,-32768,  1466,-32768,-32768,-32768,-32768,-32768,   410,
  -32768,   464,-32768,   410,-32768,-32768,-32768,-32768,-32768,   414,
  -32768,-32768,-32768,-32768,   467,-32768,   427,-32768,-32768,   425,
    1076,-32768,  1076,   489,   424,  1312,-32768,   428,   432,   433,
  -32768,   507,   434,  1353,-32768,-32768,  1466,   445,   430,    83,
    1466,  1466,  1420,   376,   376,   485,   485,   485,   485,   485,
     485,   357,   357,   165,   165,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,   326,   941,-32768,-32768,   251,-32768,-32768,
  -32768,-32768,    16,   501,-32768,   231,   231,   448,-32768,   503,
    1076,-32768,   430,  1076,-32768,   489,-32768,-32768,-32768,-32768,
  -32768,-32768,   507,-32768,-32768,  1076,-32768,  1076,-32768,   451,
     458,-32768,  1466,   410,   459,-32768,-32768,-32768,-32768,   462,
  -32768,-32768,-32768,-32768,-32768,   465,-32768,   430,  1466,  1486,
     941,-32768,   941,-32768,-32768,-32768,   596,-32768,   473,   475,
  -32768,-32768,-32768,-32768,    16,  1009,-32768,-32768,   522,-32768,
     470,   471,-32768,  1076,   550,-32768,-32768,-32768,-32768,   565,
     501,-32768,-32768,   503,   472,-32768,-32768,   588,-32768,-32768,
    1076,-32768,-32768,-32768,-32768,  1443,-32768,-32768,-32768,-32768,
  -32768,   251,-32768,   529,   672,   332,   530,   531,-32768,    41,
    1076,   521,-32768,  1076,  1076,-32768,   412,   533,   672,   480,
    1466,   435,-32768,  1076,   523,  1076,-32768,   672,   460,-32768,
     481,-32768,-32768,   482,   672,  1076,   410,-32768,-32768,   483,
  -32768,-32768,   672,-32768,   593,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   399,-32768,-32768,   493,   420,    -7,-32768,-32768,-32768,
     468,  -147,-32768,-32768,-32768,   126,  -126,-32768,   371,   215,
  -32768,-32768,-32768,-32768,-32768,  -142,-32768,   164,-32768,   163,
  -32768,-32768,  -167,  -237,  -392,  -328,-32768,-32768,  -471,-32768,
  -32768,-32768,  -277,  -282,-32768,  -481,  -480,   398,  -191,  -196,
    -161,-32768,  -345,   -62,-32768,-32768,-32768,   586,-32768,     1,
       3,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   221,
    -143,-32768,-32768,-32768,   297,-32768,-32768,-32768,-32768,   157,
  -32768,-32768,-32768,-32768,-32768,  -113,-32768,-32768,   479,   -32,
     391,   474,   476,   -84,-32768,   -90,-32768,-32768,-32768,-32768,
  -32768,   288,-32768,-32768,   290,-32768
};


#define	YYLAST		1511


static const short yytable[] =
{
      40,   181,   169,   170,   171,    17,    21,    25,   155,   145,
     247,   409,   102,   240,   154,   411,   202,   422,   205,   447,
      59,    60,   280,   281,   282,    13,    65,   343,    27,    28,
     284,    29,    68,    49,    27,    28,    48,    29,   297,   298,
     554,   147,   254,   521,   148,    27,    28,   163,    29,   104,
     105,   537,   106,   109,   105,   540,   110,   534,  -174,  -174,
     546,   287,   290,   269,    64,   549,   542,    53,   149,   273,
     552,    37,   473,   548,    54,    46,    52,    37,   457,    47,
     300,   553,   301,   302,   303,   178,   304,   305,    37,   306,
     333,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   332,
     375,  -208,  -212,     2,   254,   464,     3,     4,     5,   180,
      47,     6,   287,   327,   287,   525,    54,    27,    28,   182,
      29,   287,   258,   259,   199,    27,    28,   200,    29,   263,
     192,   376,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   421,    15,    16,   155,   290,   443,
      37,    61,   436,   154,    43,    44,   271,   272,    37,   138,
     139,   140,   141,   142,   355,   319,   320,   321,   322,   323,
     324,    67,   262,    62,   143,   138,   139,   140,   141,   142,
     499,   376,   501,    27,    28,   504,    29,   363,    27,    28,
     143,    29,   371,   344,   345,   286,   346,   514,   550,   516,
     304,   305,   132,   306,   421,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   442,    56,    57,   133,    58,    70,    71,
     144,    37,    63,   188,   189,   208,   209,    66,   103,   118,
     348,   134,   376,    27,    28,   358,    29,   403,   107,   405,
     108,   357,   357,   463,   458,  -189,   459,  -197,   359,   121,
     124,   425,   197,   125,   128,   367,   150,   368,   156,   432,
      27,    28,   157,    29,    27,    28,   369,    29,   159,   442,
     162,   442,   451,   452,   361,   164,    37,  -245,   168,   172,
     173,   174,   175,   253,   497,   182,   -61,   185,    30,    31,
      32,    33,   505,   186,   187,   194,   191,   190,    34,    35,
      36,   193,   195,    37,   216,   304,   305,    37,   306,   515,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   201,   526,
     217,   248,   530,   531,    27,    28,   246,    29,   251,   255,
     265,   270,   538,   261,   530,   317,   318,   319,   320,   321,
     322,   323,   324,   340,   530,   519,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   268,   274,   275,   348,   276,    37,   277,   294,
     295,   296,   299,   325,   338,   304,   305,   326,   306,   522,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   304,   305,
     334,   306,   335,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   337,   341,   304,   305,   401,   306,   495,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   342,   350,   351,   352,
     360,    74,   353,   354,   402,   408,   423,   410,   414,   532,
     417,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   418,   420,   424,   430,   427,    15,    16,   435,   428,
     429,   431,   536,    76,    77,    78,    79,    80,    81,    82,
      83,    84,   434,    85,   448,   453,   454,   461,    86,    87,
      88,    89,    90,    91,    92,    93,   462,   543,   465,   491,
     467,   492,   500,   470,   502,   503,    94,   506,   510,   520,
     523,   524,   527,   533,   535,   545,   547,   539,   304,   305,
     551,   306,   152,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   304,   305,   555,   306,   245,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   218,   219,   279,   177,   220,   509,
     198,   328,   444,   221,   471,   472,   222,   223,   293,   224,
     138,   139,   140,   141,   142,   474,   475,   476,   477,   478,
     111,   479,   480,   481,   412,   143,   211,   508,   336,   507,
     482,   483,   484,   426,     0,     0,     0,     0,   225,   226,
     227,   228,   229,   433,     0,     0,   230,   256,     0,   257,
       0,   231,   512,     0,     0,     0,     0,   232,     0,   233,
     485,   408,   486,     0,     0,     0,     0,   234,   235,   236,
     218,   219,     0,     0,   220,     0,     0,     0,     0,   221,
       0,     0,   222,   223,     0,   224,   138,   139,   140,   141,
     142,   474,   475,   476,   477,   478,     0,   479,   480,   481,
       0,   143,     0,     0,     0,     0,   482,   483,   484,     0,
       0,     0,     0,     0,   225,   226,   227,   228,   229,     0,
       0,     0,   230,     0,     0,     0,     0,   231,     0,     0,
       0,     0,     0,   232,     0,   233,   485,   408,   218,   219,
       0,     0,   220,   234,   235,   236,     0,   221,     0,    27,
     285,   223,    29,   224,   138,   139,   140,   141,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   225,   226,   227,   228,   229,     0,     0,     0,
     230,     0,    37,     0,     0,   231,     0,     0,     0,     0,
       0,   232,     0,   233,     0,   218,   219,     0,     0,   220,
       0,   234,   235,   236,   221,     0,     0,   222,   223,   288,
     224,   138,   139,   140,   141,   142,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   289,   225,
     226,   227,   228,   229,     0,     0,     0,   230,     0,     0,
       0,     0,   231,     0,     0,     0,     0,     0,   232,     0,
     233,     0,   218,   219,     0,     0,   220,     0,   234,   235,
     236,   221,     0,     0,   222,   329,     0,   224,   138,   139,
     140,   141,   142,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   225,   226,   227,   228,
     229,     0,     0,     0,   230,   330,     0,     0,     0,   231,
       0,     0,     0,     0,     0,   232,     0,   233,     0,   218,
     219,     0,     0,   220,   331,   234,   235,   236,   221,     0,
       0,   222,   223,     0,   224,   138,   139,   140,   141,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   225,   226,   227,   228,   229,     0,     0,
       0,   230,     0,     0,     0,     0,   231,     0,     0,     0,
       0,     0,   232,     0,   233,     0,   438,   218,   219,     0,
       0,   220,   234,   235,   236,     0,   221,     0,     0,   222,
     223,     0,   224,   138,   139,   140,   141,   142,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   225,   226,   227,   228,   229,     0,     0,     0,   230,
       0,     0,     0,     0,   231,     0,     0,     0,     0,     0,
     232,     0,   233,   496,   218,   219,     0,     0,   220,     0,
     234,   235,   236,   221,     0,     0,   222,   223,     0,   224,
     138,   139,   140,   141,   142,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   225,   226,
     227,   228,   229,     0,     0,     0,   230,     0,     0,     0,
       0,   231,     0,     0,     0,     0,     0,   232,     0,   233,
       0,   218,   219,     0,     0,   220,     0,   234,   235,   236,
     221,     0,     0,   292,   223,     0,   224,   138,   139,   140,
     141,   142,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   221,     0,     0,   283,   223,     0,   224,
     138,   139,   140,   141,   142,   225,   226,   227,   228,   229,
       0,     0,     0,   230,     0,   143,     0,     0,   231,     0,
       0,     0,     0,     0,   232,     0,   233,     0,   225,   226,
     227,   228,   229,     0,   234,   235,   236,    74,     0,     0,
       0,   231,     0,     0,     0,     0,     0,   232,     0,   233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
      75,     0,    15,    16,     0,     0,     0,     0,     0,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    74,    85,
       0,     0,     0,     0,    86,    87,    88,    89,    90,    91,
      92,    93,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    94,    15,    16,     0,     0,     0,     0,     0,
      76,    77,    78,    79,    80,    81,    82,    83,    84,   362,
      85,     0,     0,     0,     0,    86,    87,    88,    89,    90,
      91,    92,    93,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    94,    15,    16,     0,     0,     0,     0,
       0,    76,    77,    78,    79,    80,    81,    82,    83,    84,
     370,    85,     0,     0,     0,     0,    86,    87,    88,    89,
      90,    91,    92,    93,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    94,    15,    16,     0,     0,     0,
       0,     0,    76,    77,    78,    79,    80,    81,    82,    83,
      84,     0,    85,     0,     0,     0,     0,    86,    87,    88,
      89,    90,    91,    92,    93,     0,     0,     0,     0,     0,
       0,     0,     0,   304,   305,    94,   306,   437,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   304,   305,     0,   306,
     518,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   304,
     305,     0,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324
};

static const short yycheck[] =
{
       7,   127,   115,   116,   117,     4,     5,     6,    98,    71,
     177,   339,    44,   174,    98,   343,   158,   362,   161,   411,
      27,    28,   218,   219,   220,    33,    33,   264,    29,    30,
     221,    32,    39,     7,    29,    30,    30,    32,   234,   235,
       0,    30,   189,   514,    33,    29,    30,    15,    32,    48,
      49,   532,    49,    52,    53,   535,    53,   528,    18,    19,
     541,   222,   223,   206,    59,   545,   537,     7,    75,   212,
     551,    72,   464,   544,    14,    84,    30,    72,   423,    88,
      27,   552,    29,    30,    31,    86,     3,     4,    72,     6,
     251,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,   251,
     301,    85,    85,    73,   261,   443,    76,    77,    78,   126,
      88,    81,   283,   249,   285,    84,    14,    29,    30,    88,
      32,   292,   194,   195,    30,    29,    30,    33,    32,   201,
     147,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   360,    32,    33,   257,   329,   406,
      72,    33,    89,   257,    18,    19,   208,   209,    72,    34,
      35,    36,    37,    38,    86,    20,    21,    22,    23,    24,
      25,    85,   199,    33,    49,    34,    35,    36,    37,    38,
     477,   362,   479,    29,    30,   482,    32,   291,    29,    30,
      49,    32,   296,    79,    80,   222,    82,   499,   546,   501,
       3,     4,    48,     6,   420,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,   404,    23,    24,    72,    26,    30,    31,
      89,    72,    85,    87,    88,    18,    19,    84,    33,    87,
     267,    87,   423,    29,    30,    86,    32,   329,    85,   331,
      85,   278,   279,   440,   435,    85,   437,    85,   285,    33,
      85,   365,    48,    33,    33,   292,     3,   294,     7,   373,
      29,    30,     3,    32,    29,    30,   295,    32,    87,   460,
      87,   462,   415,   416,    87,    85,    72,    76,    85,     3,
       3,     3,    88,    48,   475,    88,     3,    87,    57,    58,
      59,    60,   483,    87,    33,    90,    34,    89,    67,    68,
      69,    87,    31,    72,    85,     3,     4,    72,     6,   500,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    90,   520,
      85,    84,   523,   524,    29,    30,    86,    32,     3,    87,
      86,    76,   533,    88,   535,    18,    19,    20,    21,    22,
      23,    24,    25,    48,   545,   511,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    86,    76,    76,   412,    76,    72,    74,    30,
      30,    30,    34,    93,    88,     3,     4,    86,     6,    87,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,     3,     4,
      87,     6,    33,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    84,    87,     3,     4,    34,     6,   474,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    84,    86,    84,    84,
      87,     7,    86,    30,    33,    85,     7,    33,    84,    87,
      33,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    84,    87,    89,     7,    87,    32,    33,    88,    87,
      87,    87,    87,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    87,    49,    33,    87,    33,    86,    54,    55,
      56,    57,    58,    59,    60,    61,    88,    87,    89,    76,
      88,    76,    30,    88,    84,    84,    72,     7,    86,    30,
      30,    30,    41,    30,    84,    84,    84,    44,     3,     4,
      87,     6,    88,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,     3,     4,     0,     6,   175,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    18,    19,   217,   124,    22,   493,
     152,   250,   407,    27,   460,   462,    30,    31,   230,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      54,    45,    46,    47,   347,    49,   167,   490,   257,    84,
      54,    55,    56,   365,    -1,    -1,    -1,    -1,    62,    63,
      64,    65,    66,   373,    -1,    -1,    70,   193,    -1,   193,
      -1,    75,    84,    -1,    -1,    -1,    -1,    81,    -1,    83,
      84,    85,    86,    -1,    -1,    -1,    -1,    91,    92,    93,
      18,    19,    -1,    -1,    22,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    30,    31,    -1,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    -1,    45,    46,    47,
      -1,    49,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,
      -1,    -1,    -1,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    81,    -1,    83,    84,    85,    18,    19,
      -1,    -1,    22,    91,    92,    93,    -1,    27,    -1,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    -1,    72,    -1,    -1,    75,    -1,    -1,    -1,    -1,
      -1,    81,    -1,    83,    -1,    18,    19,    -1,    -1,    22,
      -1,    91,    92,    93,    27,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    18,    19,    -1,    -1,    22,    -1,    91,    92,
      93,    27,    -1,    -1,    30,    31,    -1,    33,    34,    35,
      36,    37,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    -1,    -1,    -1,    75,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    18,
      19,    -1,    -1,    22,    90,    91,    92,    93,    27,    -1,
      -1,    30,    31,    -1,    33,    34,    35,    36,    37,    38,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    83,    -1,    85,    18,    19,    -1,
      -1,    22,    91,    92,    93,    -1,    27,    -1,    -1,    30,
      31,    -1,    33,    34,    35,    36,    37,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    83,    84,    18,    19,    -1,    -1,    22,    -1,
      91,    92,    93,    27,    -1,    -1,    30,    31,    -1,    33,
      34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,
      -1,    18,    19,    -1,    -1,    22,    -1,    91,    92,    93,
      27,    -1,    -1,    30,    31,    -1,    33,    34,    35,    36,
      37,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    27,    -1,    -1,    30,    31,    -1,    33,
      34,    35,    36,    37,    38,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    -1,    49,    -1,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    62,    63,
      64,    65,    66,    -1,    91,    92,    93,     7,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      30,    -1,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    47,     7,    49,
      -1,    -1,    -1,    -1,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    72,    32,    33,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    44,    45,    46,    47,     7,
      49,    -1,    -1,    -1,    -1,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    32,    33,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    42,    43,    44,    45,    46,    47,
       7,    49,    -1,    -1,    -1,    -1,    54,    55,    56,    57,
      58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    72,    32,    33,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    -1,    -1,    -1,    -1,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,    72,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,     3,     4,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,     3,
       4,    -1,     6,    -1,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,     6,    -1,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 2:
#line 203 "../../../../tools/qfcc/source/qc-parse.y"
{if (current_class) PARSE_ERROR;}
    break;
case 5:
#line 208 "../../../../tools/qfcc/source/qc-parse.y"
{ current_storage = st_global; yyval.type = yyvsp[0].type; }
    break;
case 6:
#line 208 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 7:
#line 209 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[0].type; }
    break;
case 8:
#line 209 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 9:
#line 210 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 10:
#line 212 "../../../../tools/qfcc/source/qc-parse.y"
{ struct_type = new_struct (yyvsp[0].string_val); }
    break;
case 11:
#line 212 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 12:
#line 214 "../../../../tools/qfcc/source/qc-parse.y"
{ struct_type = new_union (yyvsp[0].string_val); }
    break;
case 13:
#line 214 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 14:
#line 216 "../../../../tools/qfcc/source/qc-parse.y"
{ process_enum (yyvsp[-2].expr); }
    break;
case 15:
#line 218 "../../../../tools/qfcc/source/qc-parse.y"
{ new_typedef (yyvsp[0].string_val, yyvsp[-1].type); }
    break;
case 16:
#line 220 "../../../../tools/qfcc/source/qc-parse.y"
{
			process_enum (yyvsp[-3].expr);
			new_typedef (yyvsp[0].string_val, &type_integer);
		}
    break;
case 19:
#line 232 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[0].type; }
    break;
case 20:
#line 232 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 21:
#line 236 "../../../../tools/qfcc/source/qc-parse.y"
{ current_storage = st_extern; }
    break;
case 22:
#line 237 "../../../../tools/qfcc/source/qc-parse.y"
{ current_storage = st_static; }
    break;
case 23:
#line 238 "../../../../tools/qfcc/source/qc-parse.y"
{ current_storage = st_system; }
    break;
case 26:
#line 245 "../../../../tools/qfcc/source/qc-parse.y"
{
			class_t    *class = get_class (yyvsp[-1].string_val, 0);

			if (class) {
				copy_struct_fields (struct_type, class->ivars);
			} else {
				error (0, "undefined symbol `%s'", yyvsp[-1].string_val);
			}
		}
    break;
case 27:
#line 257 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[0].type; }
    break;
case 28:
#line 257 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 30:
#line 263 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (yyvsp[0].expr) {
				yyvsp[0].expr->next = yyvsp[-2].expr;
				yyval.expr = yyvsp[0].expr;
			} else {
				yyval.expr = yyvsp[-2].expr;
			}
		}
    break;
case 31:
#line 274 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_name_expr (yyvsp[0].string_val); }
    break;
case 32:
#line 276 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = 0;
			if (yyvsp[0].expr->type == ex_def && yyvsp[0].expr->e.def->constant)
				yyvsp[0].expr = constant_expr (yyvsp[0].expr);
			if (yyvsp[0].expr->type < ex_string) {
				error (yyvsp[0].expr, "non-constant initializer");
			} else if (yyvsp[0].expr->type != ex_integer) {
				error (yyvsp[0].expr, "invalid initializer type");
			} else {
				yyval.expr = new_binary_expr ('=', new_name_expr (yyvsp[-2].string_val), yyvsp[0].expr);
			}
		}
    break;
case 33:
#line 291 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = field_type (yyvsp[0].type); }
    break;
case 34:
#line 292 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[0].type; }
    break;
case 35:
#line 294 "../../../../tools/qfcc/source/qc-parse.y"
{
			current_params = yyvsp[0].param;
			yyval.type = parse_params (yyvsp[-1].type, yyvsp[0].param);
		}
    break;
case 36:
#line 301 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[-1].type; }
    break;
case 37:
#line 303 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (yyvsp[0].expr)
				yyval.type = array_type (yyvsp[-1].type, yyvsp[0].expr->e.integer_val);
			else
				yyval.type = pointer_type (yyvsp[-1].type);
		}
    break;
case 38:
#line 309 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[0].type; }
    break;
case 39:
#line 313 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[0].type; }
    break;
case 40:
#line 315 "../../../../tools/qfcc/source/qc-parse.y"
{
			class_t    *class = get_class (yyvsp[0].string_val, 0);
			if (!class) {
				error (0, "undefined symbol `%s'", yyvsp[0].string_val);
				class = get_class (0, 1);
			}
			yyval.type = class->type;
		}
    break;
case 41:
#line 326 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = reverse_params (yyvsp[-1].param); }
    break;
case 42:
#line 328 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.param = new_param (0, 0, 0);
			yyval.param->next = yyvsp[-3].param;
			yyval.param = reverse_params (yyval.param);
		}
    break;
case 43:
#line 333 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = new_param (0, 0, 0); }
    break;
case 44:
#line 335 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (yyvsp[-1].type != &type_void)
				PARSE_ERROR;
			yyval.param = 0;
		}
    break;
case 45:
#line 340 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = 0; }
    break;
case 47:
#line 346 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[0].param->next = yyvsp[-2].param;
			yyval.param = yyvsp[0].param;
		}
    break;
case 48:
#line 353 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = new_param (0, yyvsp[-1].type, yyvsp[0].string_val); }
    break;
case 49:
#line 358 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (yyvsp[-1].expr->type != ex_integer || yyvsp[-1].expr->e.integer_val < 1) {
				error (0, "invalid array size");
				yyval.expr = 0;
			} else {
				yyval.expr = yyvsp[-1].expr;
			}
		}
    break;
case 50:
#line 366 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = 0; }
    break;
case 51:
#line 370 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[-2].type; }
    break;
case 54:
#line 375 "../../../../tools/qfcc/source/qc-parse.y"
{ new_struct_field (struct_type, yyvsp[-1].type, yyvsp[0].string_val, vis_public); }
    break;
case 55:
#line 379 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[-2].type; }
    break;
case 58:
#line 385 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (yyvsp[-1].def && !yyvsp[-1].def->local
				&& yyvsp[-1].def->type->type != ev_func)
				def_initialized (yyvsp[-1].def);
		}
    break;
case 59:
#line 394 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (current_scope->type == sc_local
				&& current_scope->parent->type == sc_params) {
				def_t      *def = get_def (0, yyvsp[0].string_val, current_scope, st_none);
				if (def) {
					if (def->scope->type == sc_params)
						warning (0, "local %s shadows param %s", yyvsp[0].string_val, def->name);
				}
			}
			yyval.def = get_def (yyvsp[-1].type, yyvsp[0].string_val, current_scope, current_storage);
		}
    break;
case 60:
#line 408 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 61:
#line 409 "../../../../tools/qfcc/source/qc-parse.y"
{ element_flag = yyvsp[0].def->type->type != ev_func; yyval.def = yyvsp[0].def; }
    break;
case 62:
#line 410 "../../../../tools/qfcc/source/qc-parse.y"
{ element_flag = 0; }
    break;
case 63:
#line 415 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (current_scope->type == sc_local) {
				append_expr (local_expr,
							 assign_expr (new_def_expr (yyvsp[-2].def), yyvsp[0].expr));
				def_initialized (yyvsp[-2].def);
			} else {
				if (yyvsp[0].expr->type == ex_def && yyvsp[0].expr->e.def->constant)
					yyvsp[0].expr = constant_expr (yyvsp[0].expr);
				if (yyvsp[0].expr->type >= ex_string) {
					if (yyvsp[-2].def->constant) {
						error (yyvsp[0].expr, "%s re-initialized", yyvsp[-2].def->name);
					} else {
						if (yyvsp[-2].def->type->type == ev_func) {
							PARSE_ERROR;
						} else {
							ReuseConstant (yyvsp[0].expr,  yyvsp[-2].def);
						}
					}
				} else {
					error (yyvsp[0].expr, "non-constant expression used for initializer");
				}
			}
		}
    break;
case 64:
#line 438 "../../../../tools/qfcc/source/qc-parse.y"
{ current_init = new_block_expr (); }
    break;
case 65:
#line 439 "../../../../tools/qfcc/source/qc-parse.y"
{
			init_elements (yyvsp[-5].def, yyvsp[-1].expr);
			current_init = 0;
		}
    break;
case 66:
#line 444 "../../../../tools/qfcc/source/qc-parse.y"
{
			build_builtin_function (yyvsp[-3].def, yyvsp[0].expr);
		}
    break;
case 67:
#line 447 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.def = yyvsp[-2].def; }
    break;
case 68:
#line 449 "../../../../tools/qfcc/source/qc-parse.y"
{
			build_function (yyvsp[-2].function);
			if (yyvsp[-4].expr) {
				yyvsp[-4].expr->next = yyvsp[-1].expr;
				emit_function (yyvsp[-2].function, yyvsp[-4].expr);
			} else {
				emit_function (yyvsp[-2].function, yyvsp[-1].expr);
			}
			finish_function (yyvsp[-2].function);
		}
    break;
case 69:
#line 463 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = 0;
		}
    break;
case 70:
#line 466 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = &type_function; }
    break;
case 71:
#line 467 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (yyvsp[-4].expr->type == ex_integer)
				convert_int (yyvsp[-4].expr);
			if (yyvsp[-4].expr->type != ex_float)
				error (yyvsp[-4].expr, "invalid type for frame number");
			if (yyvsp[-1].def->type->type != ev_func)
				error (yyvsp[-4].expr, "invalid type for think");

			yyval.expr = new_binary_expr ('s', yyvsp[-4].expr, new_def_expr (yyvsp[-1].def));
		}
    break;
case 72:
#line 481 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = new_block_expr ();
		}
    break;
case 73:
#line 485 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = current_init;
		}
    break;
case 74:
#line 492 "../../../../tools/qfcc/source/qc-parse.y"
{
			append_expr (current_init, yyvsp[0].expr);
		}
    break;
case 75:
#line 496 "../../../../tools/qfcc/source/qc-parse.y"
{
			append_expr (current_init, yyvsp[0].expr);
		}
    break;
case 76:
#line 503 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = current_init;
			current_init = new_block_expr ();
		}
    break;
case 77:
#line 508 "../../../../tools/qfcc/source/qc-parse.y"
{
			current_init = yyvsp[-1].expr;
		}
    break;
case 78:
#line 512 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = yyvsp[-2].expr;
		}
    break;
case 79:
#line 516 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = yyvsp[0].expr;
		}
    break;
case 82:
#line 528 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.function = current_func = new_function (yyvsp[0].def->name);
			yyval.function->def = yyvsp[0].def;
			yyval.function->refs = new_reloc (yyval.function->def->ofs, rel_def_func);
			yyval.function->code = pr.code->size;
			if (options.code.debug) {
				pr_lineno_t *lineno = new_lineno ();
				yyval.function->aux->source_line = yyval.function->def->line;
				yyval.function->aux->line_info = lineno - pr.linenos;
				yyval.function->aux->local_defs = pr.num_locals;

				lineno->fa.func = yyval.function->aux - pr.auxfunctions;
			}
			build_scope (yyval.function, yyvsp[0].def, current_params);
			current_scope = yyval.function->scope;
		}
    break;
case 83:
#line 548 "../../../../tools/qfcc/source/qc-parse.y"
{
			current_scope = current_scope->parent;
		}
    break;
case 84:
#line 555 "../../../../tools/qfcc/source/qc-parse.y"
{
			scope_t    *scope = new_scope (sc_local, current_scope->space,
										   current_scope);
			current_scope = scope;
		}
    break;
case 85:
#line 561 "../../../../tools/qfcc/source/qc-parse.y"
{
			def_t      *defs = current_scope->head;
			int         num_defs = current_scope->num_defs;

			flush_scope (current_scope, 1);

			current_scope = current_scope->parent;
			current_scope->num_defs += num_defs;
			*current_scope->tail = defs;
			while (*current_scope->tail) {
				current_scope->tail = &(*current_scope->tail)->def_next;
			}
			yyval.expr = yyvsp[-1].expr;
		}
    break;
case 86:
#line 579 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = new_block_expr ();
		}
    break;
case 87:
#line 583 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = append_expr (yyvsp[-1].expr, yyvsp[0].expr);
		}
    break;
case 88:
#line 589 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = 0; }
    break;
case 89:
#line 590 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = yyvsp[0].expr; }
    break;
case 90:
#line 592 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = return_expr (current_func, yyvsp[-1].expr);
		}
    break;
case 91:
#line 596 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = return_expr (current_func, 0);
		}
    break;
case 92:
#line 600 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = 0;
			if (break_label)
				yyval.expr = new_unary_expr ('g', break_label);
			else
				error (0, "break outside of loop or switch");
		}
    break;
case 93:
#line 608 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = 0;
			if (continue_label)
				yyval.expr = new_unary_expr ('g', continue_label);
			else
				error (0, "continue outside of loop");
		}
    break;
case 94:
#line 616 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = case_label_expr (switch_block, yyvsp[-1].expr);
		}
    break;
case 95:
#line 620 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = case_label_expr (switch_block, 0);
		}
    break;
case 96:
#line 624 "../../../../tools/qfcc/source/qc-parse.y"
{
			switch_block->test = yyvsp[-1].expr;
		}
    break;
case 97:
#line 628 "../../../../tools/qfcc/source/qc-parse.y"
{
			restore_local_inits (yyvsp[-1].def_list);
			free_local_inits (yyvsp[-1].def_list);
			yyval.expr = switch_expr (switch_block, break_label, yyvsp[0].expr);
			switch_block = yyvsp[-6].switch_block;
			break_label = yyvsp[-7].expr;
		}
    break;
case 98:
#line 636 "../../../../tools/qfcc/source/qc-parse.y"
{
			expr_t *l1 = new_label_expr ();
			expr_t *l2 = break_label;
			expr_t *e;

			restore_local_inits (yyvsp[-1].def_list);
			free_local_inits (yyvsp[-1].def_list);

			yyval.expr = new_block_expr ();

			e = new_binary_expr ('n', test_expr (yyvsp[-3].expr, 1), l2);
			e->line = yyvsp[-3].expr->line;
			e->file = yyvsp[-3].expr->file;
			append_expr (yyval.expr, e);
			append_expr (yyval.expr, l1);
			append_expr (yyval.expr, yyvsp[0].expr);
			append_expr (yyval.expr, continue_label);
			e = new_binary_expr ('i', test_expr (yyvsp[-3].expr, 1), l1);
			e->line = yyvsp[-3].expr->line;
			e->file = yyvsp[-3].expr->file;
			append_expr (yyval.expr, e);
			append_expr (yyval.expr, l2);
			break_label = yyvsp[-6].expr;
			continue_label = yyvsp[-5].expr;
		}
    break;
case 99:
#line 662 "../../../../tools/qfcc/source/qc-parse.y"
{
			expr_t *l1 = new_label_expr ();

			yyval.expr = new_block_expr ();

			append_expr (yyval.expr, l1);
			append_expr (yyval.expr, yyvsp[-5].expr);
			append_expr (yyval.expr, continue_label);
			append_expr (yyval.expr, new_binary_expr ('i', test_expr (yyvsp[-2].expr, 1), l1));
			append_expr (yyval.expr, break_label);
			break_label = yyvsp[-7].expr;
			continue_label = yyvsp[-6].expr;
		}
    break;
case 100:
#line 676 "../../../../tools/qfcc/source/qc-parse.y"
{
			current_storage = st_local;
			yyval.type = yyvsp[0].type;
			local_expr = new_block_expr ();
		}
    break;
case 101:
#line 682 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = local_expr;
			local_expr = 0;
		}
    break;
case 102:
#line 687 "../../../../tools/qfcc/source/qc-parse.y"
{
			expr_t *l1 = new_label_expr ();
			expr_t *e;

			yyval.expr = new_block_expr ();

			restore_local_inits (yyvsp[-1].def_list);
			free_local_inits (yyvsp[-1].def_list);

			e = new_binary_expr ('n', test_expr (yyvsp[-3].expr, 1), l1);
			e->line = yyvsp[-3].expr->line;
			e->file = yyvsp[-3].expr->file;
			append_expr (yyval.expr, e);
			append_expr (yyval.expr, yyvsp[0].expr);
			append_expr (yyval.expr, l1);
		}
    break;
case 103:
#line 704 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.def_list = save_local_inits (current_scope);
			restore_local_inits (yyvsp[-2].def_list);
		}
    break;
case 104:
#line 709 "../../../../tools/qfcc/source/qc-parse.y"
{
			expr_t     *l1 = new_label_expr ();
			expr_t     *l2 = new_label_expr ();
			expr_t     *e;
			hashtab_t  *merged;
			hashtab_t  *else_ini;

			yyval.expr = new_block_expr ();

			else_ini = save_local_inits (current_scope);

			restore_local_inits (yyvsp[-4].def_list);
			free_local_inits (yyvsp[-4].def_list);

			e = new_binary_expr ('n', test_expr (yyvsp[-6].expr, 1), l1);
			e->line = yyvsp[-6].expr->line;
			e->file = yyvsp[-6].expr->file;
			append_expr (yyval.expr, e);

			append_expr (yyval.expr, yyvsp[-3].expr);

			e = new_unary_expr ('g', l2);
			append_expr (yyval.expr, e);

			append_expr (yyval.expr, l1);
			append_expr (yyval.expr, yyvsp[0].expr);
			append_expr (yyval.expr, l2);
			merged = merge_local_inits (yyvsp[-1].def_list, else_ini);
			restore_local_inits (merged);
			free_local_inits (merged);
			free_local_inits (else_ini);
			free_local_inits (yyvsp[-1].def_list);
		}
    break;
case 105:
#line 744 "../../../../tools/qfcc/source/qc-parse.y"
{
			expr_t *l1 = new_label_expr ();
			expr_t *l2 = break_label;

			restore_local_inits (yyvsp[-1].def_list);
			free_local_inits (yyvsp[-1].def_list);

			yyval.expr = new_block_expr ();

			append_expr (yyval.expr, yyvsp[-7].expr);
			if (yyvsp[-5].expr)
				append_expr (yyval.expr, new_binary_expr ('n', test_expr (yyvsp[-5].expr, 1), l2));
			append_expr (yyval.expr, l1);
			append_expr (yyval.expr, yyvsp[0].expr);
			append_expr (yyval.expr, continue_label);
			append_expr (yyval.expr, yyvsp[-3].expr);
			if (yyvsp[-7].expr)
				append_expr (yyval.expr, new_binary_expr ('i', test_expr (yyvsp[-5].expr, 1), l1));
			append_expr (yyval.expr, l2);
			break_label = yyvsp[-10].expr;
			continue_label = yyvsp[-9].expr;
		}
    break;
case 106:
#line 767 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = yyvsp[-1].expr;
		}
    break;
case 107:
#line 774 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = break_label;
			break_label = new_label_expr ();
		}
    break;
case 108:
#line 782 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = continue_label;
			continue_label = new_label_expr ();
		}
    break;
case 109:
#line 790 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.switch_block = switch_block;
			switch_block = new_switch_block ();
		}
    break;
case 110:
#line 798 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.def_list = save_local_inits (current_scope);
		}
    break;
case 112:
#line 806 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = 0;
		}
    break;
case 114:
#line 813 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = yyvsp[0].expr; }
    break;
case 115:
#line 814 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = unary_expr ('-', yyvsp[0].expr); }
    break;
case 116:
#line 815 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = unary_expr ('!', yyvsp[0].expr); }
    break;
case 117:
#line 816 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = unary_expr ('~', yyvsp[0].expr); }
    break;
case 118:
#line 817 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = address_expr (yyvsp[0].expr, 0, 0); }
    break;
case 119:
#line 818 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = sizeof_expr (yyvsp[0].expr, 0); }
    break;
case 120:
#line 819 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = sizeof_expr (0, yyvsp[-1].type); }
    break;
case 121:
#line 823 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_name_expr (yyvsp[0].string_val); }
    break;
case 122:
#line 824 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_name_expr (".args"); }
    break;
case 123:
#line 825 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = argc_expr (); }
    break;
case 124:
#line 826 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = argv_expr (); }
    break;
case 125:
#line 827 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_self_expr (); }
    break;
case 126:
#line 828 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_this_expr (); }
    break;
case 127:
#line 829 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = yyvsp[0].expr; }
    break;
case 128:
#line 830 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = yyvsp[-1].expr; yyval.expr->paren = 1; }
    break;
case 129:
#line 831 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = function_expr (yyvsp[-3].expr, yyvsp[-1].expr); }
    break;
case 130:
#line 832 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = array_expr (yyvsp[-3].expr, yyvsp[-1].expr); }
    break;
case 131:
#line 833 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('.', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 132:
#line 834 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = incop_expr (yyvsp[-1].op, yyvsp[0].expr, 0); }
    break;
case 133:
#line 835 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = incop_expr (yyvsp[0].op, yyvsp[-1].expr, 1); }
    break;
case 134:
#line 836 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = yyvsp[0].expr; }
    break;
case 136:
#line 841 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = cast_expr (yyvsp[-2].type, yyvsp[0].expr); }
    break;
case 138:
#line 846 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = assign_expr (yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 139:
#line 847 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = asx_expr (yyvsp[-1].op, yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 140:
#line 848 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = conditional_expr (yyvsp[-4].expr, yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 141:
#line 849 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (AND, yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 142:
#line 850 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (OR,  yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 143:
#line 851 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (EQ,  yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 144:
#line 852 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (NE,  yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 145:
#line 853 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (LE,  yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 146:
#line 854 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (GE,  yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 147:
#line 855 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (LT,  yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 148:
#line 856 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (GT,  yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 149:
#line 857 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (SHL, yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 150:
#line 858 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr (SHR, yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 151:
#line 859 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('+', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 152:
#line 860 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('-', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 153:
#line 861 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('*', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 154:
#line 862 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('/', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 155:
#line 863 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('&', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 156:
#line 864 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('|', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 157:
#line 865 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('^', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 158:
#line 866 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = binary_expr ('%', yyvsp[-2].expr, yyvsp[0].expr); }
    break;
case 159:
#line 870 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = 0; }
    break;
case 160:
#line 871 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = yyvsp[0].expr; }
    break;
case 162:
#line 877 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[0].expr->next = yyvsp[-2].expr;
			yyval.expr = yyvsp[0].expr;
		}
    break;
case 163:
#line 884 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_float_expr (yyvsp[0].float_val); }
    break;
case 164:
#line 885 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = yyvsp[0].expr; }
    break;
case 165:
#line 886 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_vector_expr (yyvsp[0].vector_val); }
    break;
case 166:
#line 887 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_quaternion_expr (yyvsp[0].quaternion_val); }
    break;
case 167:
#line 888 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_integer_expr (yyvsp[0].integer_val); }
    break;
case 168:
#line 889 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_nil_expr (); }
    break;
case 169:
#line 893 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_string_expr (yyvsp[0].string_val); }
    break;
case 170:
#line 895 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = binary_expr ('+', yyvsp[-1].expr, new_string_expr (yyvsp[0].string_val));
		}
    break;
case 171:
#line 901 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 174:
#line 904 "../../../../tools/qfcc/source/qc-parse.y"
{ if (!current_class) PARSE_ERROR; }
    break;
case 176:
#line 906 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (!current_class)
				PARSE_ERROR;
			else
				class_finish (current_class);
			current_class = 0;
		}
    break;
case 177:
#line 917 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = new_block_expr ();
			append_expr (yyval.expr, new_name_expr (yyvsp[0].string_val));
		}
    break;
case 178:
#line 922 "../../../../tools/qfcc/source/qc-parse.y"
{
			append_expr (yyvsp[-2].expr, new_name_expr (yyvsp[0].string_val));
			yyval.expr = yyvsp[-2].expr;
		}
    break;
case 179:
#line 930 "../../../../tools/qfcc/source/qc-parse.y"
{
			expr_t     *e;
			for (e = yyvsp[-1].expr->e.block.head; e; e = e->next)
				get_class (e->e.string_val, 1);
		}
    break;
case 182:
#line 944 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.class = get_class (yyvsp[0].string_val, 0);
			if (!yyval.class) {
				error (0, "undefined symbol `%s'", yyvsp[0].string_val);
				yyval.class = get_class (0, 1);
			}
		}
    break;
case 183:
#line 955 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.class = get_class (yyvsp[0].string_val, 1);
			if (yyval.class->defined) {
				error (0, "redefinition of `%s'", yyvsp[0].string_val);
				yyval.class = get_class (0, 1);
			}
		}
    break;
case 184:
#line 966 "../../../../tools/qfcc/source/qc-parse.y"
{
			if (yyvsp[-2].class->super_class != yyvsp[0].class)
				error (0, "%s is not a super class of %s", yyvsp[0].class->name, yyvsp[-2].class->name);
			yyval.class = yyvsp[-2].class;
		}
    break;
case 185:
#line 975 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[-2].class->super_class = yyvsp[0].class;
			yyval.class = yyvsp[-2].class;
		}
    break;
case 186:
#line 983 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.category = get_category (yyvsp[-3].string_val, yyvsp[-1].string_val, 0);
			if (!yyval.category) {
				error (0, "undefined category `%s (%s)'", yyvsp[-3].string_val, yyvsp[-1].string_val);
				yyval.category = get_category (0, 0, 1);
			}
		}
    break;
case 187:
#line 994 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.category = get_category (yyvsp[-3].string_val, yyvsp[-1].string_val, 1);
			if (yyval.category->defined) {
				error (0, "redefinition of category `%s (%s)'", yyvsp[-3].string_val, yyvsp[-1].string_val);
				yyval.category = get_category (0, 0, 1);
			}
		}
    break;
case 188:
#line 1005 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.protocol = get_protocol (yyvsp[0].string_val, 0);
			if (yyval.protocol) {
				error (0, "redefinition of %s", yyvsp[0].string_val);
				yyval.protocol = get_protocol (0, 1);
			} else {
				yyval.protocol = get_protocol (yyvsp[0].string_val, 1);
			}
		}
    break;
case 189:
#line 1018 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_protocol_methods (yyvsp[-1].class, yyvsp[0].expr);}
    break;
case 190:
#line 1019 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.class = yyvsp[-3].class; }
    break;
case 191:
#line 1020 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_ivars (yyvsp[-6].class, yyvsp[-1].type); yyval.class = yyvsp[-6].class; }
    break;
case 192:
#line 1021 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_methods (yyvsp[-8].class, yyvsp[0].methodlist); }
    break;
case 193:
#line 1022 "../../../../tools/qfcc/source/qc-parse.y"
{ current_class = 0; }
    break;
case 194:
#line 1024 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_protocol_methods (yyvsp[-1].class, yyvsp[0].expr); yyval.class = yyvsp[-1].class; }
    break;
case 195:
#line 1025 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_methods (yyvsp[-3].class, yyvsp[0].methodlist); }
    break;
case 196:
#line 1026 "../../../../tools/qfcc/source/qc-parse.y"
{ current_class = 0; }
    break;
case 197:
#line 1028 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_protocol_methods (yyvsp[-1].class, yyvsp[0].expr);}
    break;
case 198:
#line 1029 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.class = yyvsp[-3].class; }
    break;
case 199:
#line 1030 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_ivars (yyvsp[-6].class, yyvsp[-1].type); yyval.class = yyvsp[-6].class; }
    break;
case 200:
#line 1031 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_methods (yyvsp[-8].class, yyvsp[0].methodlist); }
    break;
case 201:
#line 1032 "../../../../tools/qfcc/source/qc-parse.y"
{ current_class = 0; }
    break;
case 202:
#line 1034 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_protocol_methods (yyvsp[-1].class, yyvsp[0].expr); yyval.class = yyvsp[-1].class; }
    break;
case 203:
#line 1035 "../../../../tools/qfcc/source/qc-parse.y"
{ class_add_methods (yyvsp[-3].class, yyvsp[0].methodlist); }
    break;
case 204:
#line 1036 "../../../../tools/qfcc/source/qc-parse.y"
{ current_class = 0; }
    break;
case 205:
#line 1038 "../../../../tools/qfcc/source/qc-parse.y"
{ category_add_protocol_methods (yyvsp[-1].category, yyvsp[0].expr); yyval.class = yyvsp[-1].category->class;}
    break;
case 206:
#line 1039 "../../../../tools/qfcc/source/qc-parse.y"
{ category_add_methods (yyvsp[-3].category, yyvsp[0].methodlist); }
    break;
case 207:
#line 1040 "../../../../tools/qfcc/source/qc-parse.y"
{ current_class = 0; }
    break;
case 208:
#line 1041 "../../../../tools/qfcc/source/qc-parse.y"
{ class_begin (&yyvsp[0].class->class_type); }
    break;
case 209:
#line 1042 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.class = yyvsp[-2].class; }
    break;
case 210:
#line 1043 "../../../../tools/qfcc/source/qc-parse.y"
{ class_check_ivars (yyvsp[-5].class, yyvsp[-1].type); }
    break;
case 211:
#line 1044 "../../../../tools/qfcc/source/qc-parse.y"
{ class_begin (&yyvsp[0].class->class_type); }
    break;
case 212:
#line 1045 "../../../../tools/qfcc/source/qc-parse.y"
{ class_begin (&yyvsp[0].class->class_type); }
    break;
case 213:
#line 1046 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.class = yyvsp[-2].class; }
    break;
case 214:
#line 1047 "../../../../tools/qfcc/source/qc-parse.y"
{ class_check_ivars (yyvsp[-5].class, yyvsp[-1].type); }
    break;
case 215:
#line 1048 "../../../../tools/qfcc/source/qc-parse.y"
{ class_begin (&yyvsp[0].class->class_type); }
    break;
case 216:
#line 1049 "../../../../tools/qfcc/source/qc-parse.y"
{ class_begin (&yyvsp[0].category->class_type); }
    break;
case 217:
#line 1054 "../../../../tools/qfcc/source/qc-parse.y"
{ protocol_add_protocol_methods (yyvsp[-1].protocol, yyvsp[0].expr); yyval.class = 0; }
    break;
case 218:
#line 1055 "../../../../tools/qfcc/source/qc-parse.y"
{ protocol_add_methods (yyvsp[-3].protocol, yyvsp[0].methodlist); }
    break;
case 220:
#line 1060 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = 0; }
    break;
case 221:
#line 1061 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = yyvsp[-1].expr->e.block.head; }
    break;
case 222:
#line 1066 "../../../../tools/qfcc/source/qc-parse.y"
{
			current_visibility = vis_protected;
			current_ivars = new_struct (0);
			if (yyvsp[0].class->super_class)
				new_struct_field (current_ivars,
								  yyvsp[0].class->super_class->ivars, 0,
								  vis_private);
		}
    break;
case 223:
#line 1075 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.type = current_ivars;
			current_ivars = 0;
		}
    break;
case 226:
#line 1087 "../../../../tools/qfcc/source/qc-parse.y"
{ current_visibility = vis_private; }
    break;
case 227:
#line 1088 "../../../../tools/qfcc/source/qc-parse.y"
{ current_visibility = vis_protected; }
    break;
case 228:
#line 1089 "../../../../tools/qfcc/source/qc-parse.y"
{ current_visibility = vis_public; }
    break;
case 231:
#line 1098 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[0].type; }
    break;
case 232:
#line 1098 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 234:
#line 1103 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.type = yyvsp[-2].type; }
    break;
case 236:
#line 1108 "../../../../tools/qfcc/source/qc-parse.y"
{
			new_struct_field (current_ivars, yyvsp[-1].type, yyvsp[0].string_val, current_visibility);
		}
    break;
case 237:
#line 1115 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[0].method->instance = 0;
			yyvsp[0].method = class_find_method (current_class, yyvsp[0].method);
		}
    break;
case 238:
#line 1120 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.def = yyvsp[-2].method->def = method_def (current_class, yyvsp[-2].method);
			current_params = yyvsp[-2].method->params;
		}
    break;
case 239:
#line 1125 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[-6].method->func = yyvsp[-2].function;
			build_function (yyvsp[-2].function);
			if (yyvsp[-4].expr) {
				yyvsp[-4].expr->next = yyvsp[-1].expr;
				emit_function (yyvsp[-2].function, yyvsp[-4].expr);
			} else {
				emit_function (yyvsp[-2].function, yyvsp[-1].expr);
			}
			finish_function (yyvsp[-2].function);
		}
    break;
case 240:
#line 1137 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[-4].method->instance = 0;
			yyvsp[-4].method = class_find_method (current_class, yyvsp[-4].method);
			yyvsp[-4].method->def = method_def (current_class, yyvsp[-4].method);

			yyvsp[-4].method->func = build_builtin_function (yyvsp[-4].method->def, yyvsp[-1].expr);
		}
    break;
case 241:
#line 1145 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[0].method->instance = 1;
			yyvsp[0].method = class_find_method (current_class, yyvsp[0].method);
		}
    break;
case 242:
#line 1150 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.def = yyvsp[-2].method->def = method_def (current_class, yyvsp[-2].method);
			current_params = yyvsp[-2].method->params;
		}
    break;
case 243:
#line 1155 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[-6].method->func = yyvsp[-2].function;
			build_function (yyvsp[-2].function);
			if (yyvsp[-4].expr) {
				yyvsp[-4].expr->next = yyvsp[-1].expr;
				emit_function (yyvsp[-2].function, yyvsp[-4].expr);
			} else {
				emit_function (yyvsp[-2].function, yyvsp[-1].expr);
			}
			finish_function (yyvsp[-2].function);
		}
    break;
case 244:
#line 1167 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[-4].method->instance = 1;
			yyvsp[-4].method = class_find_method (current_class, yyvsp[-4].method);
			yyvsp[-4].method->def = method_def (current_class, yyvsp[-4].method);

			yyvsp[-4].method->func = build_builtin_function (yyvsp[-4].method->def, yyvsp[-1].expr);
		}
    break;
case 245:
#line 1177 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.methodlist = 0; }
    break;
case 247:
#line 1182 "../../../../tools/qfcc/source/qc-parse.y"
{ }
    break;
case 248:
#line 1183 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.methodlist = new_methodlist ();
			add_method (yyval.methodlist, yyvsp[0].method);
		}
    break;
case 249:
#line 1188 "../../../../tools/qfcc/source/qc-parse.y"
{
			add_method (yyvsp[-1].methodlist, yyvsp[0].method);
			yyval.methodlist = yyvsp[-1].methodlist;
		}
    break;
case 250:
#line 1196 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[-1].method->instance = 0;
			yyvsp[-1].method->params->type = &type_Class;
			yyval.method = yyvsp[-1].method;
		}
    break;
case 251:
#line 1202 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[-1].method->instance = 1;
			if (yyvsp[-4].class)
				yyvsp[-1].method->params->type = yyvsp[-4].class->type;
			yyval.method = yyvsp[-1].method;
		}
    break;
case 252:
#line 1212 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.method = new_method (yyvsp[-2].type, yyvsp[0].param, 0); }
    break;
case 253:
#line 1214 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.method = new_method (&type_id, yyvsp[0].param, 0); }
    break;
case 254:
#line 1216 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.method = new_method (yyvsp[-3].type, yyvsp[-1].param, yyvsp[0].param); }
    break;
case 255:
#line 1218 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.method = new_method (&type_id, yyvsp[-1].param, yyvsp[0].param); }
    break;
case 256:
#line 1222 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = 0; }
    break;
case 257:
#line 1223 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = new_param (0, 0, 0); }
    break;
case 258:
#line 1224 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = yyvsp[0].param; }
    break;
case 259:
#line 1226 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.param = new_param (0, 0, 0);
			yyval.param->next = yyvsp[-2].param;
		}
    break;
case 260:
#line 1233 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = new_param (yyvsp[0].string_val, 0, 0); }
    break;
case 262:
#line 1238 "../../../../tools/qfcc/source/qc-parse.y"
{ yyvsp[0].param->next = yyvsp[-1].param; yyval.param = yyvsp[0].param; }
    break;
case 264:
#line 1243 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 266:
#line 1248 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 267:
#line 1249 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 268:
#line 1250 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 269:
#line 1251 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 270:
#line 1252 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 271:
#line 1253 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 272:
#line 1254 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 273:
#line 1255 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 274:
#line 1256 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 275:
#line 1257 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 276:
#line 1258 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 277:
#line 1259 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 278:
#line 1260 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 279:
#line 1261 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 280:
#line 1262 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 281:
#line 1263 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 282:
#line 1264 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 283:
#line 1265 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.string_val = save_string (yytext); }
    break;
case 284:
#line 1270 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = new_param (yyvsp[-5].string_val, yyvsp[-2].type, yyvsp[0].string_val); }
    break;
case 285:
#line 1272 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = new_param (yyvsp[-2].string_val, &type_id, yyvsp[0].string_val); }
    break;
case 286:
#line 1274 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = new_param ("", yyvsp[-2].type, yyvsp[0].string_val); }
    break;
case 287:
#line 1276 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.param = new_param ("", &type_id, yyvsp[0].string_val); }
    break;
case 289:
#line 1281 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = selector_expr (yyvsp[-1].keywordarg); }
    break;
case 290:
#line 1282 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = protocol_expr (yyvsp[-1].string_val); }
    break;
case 291:
#line 1283 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = encode_expr (yyvsp[-1].type); }
    break;
case 293:
#line 1288 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = message_expr (yyvsp[-2].expr, yyvsp[-1].keywordarg); }
    break;
case 295:
#line 1293 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_name_expr (yyvsp[0].string_val); }
    break;
case 296:
#line 1294 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_name_expr ("super"); }
    break;
case 297:
#line 1298 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.keywordarg = new_keywordarg (yyvsp[0].string_val, 0); }
    break;
case 300:
#line 1305 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[0].keywordarg->next = yyvsp[-1].keywordarg;
			yyval.keywordarg = yyvsp[0].keywordarg;
		}
    break;
case 301:
#line 1312 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.keywordarg = new_keywordarg (yyvsp[-2].string_val, yyvsp[0].expr); }
    break;
case 302:
#line 1313 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.keywordarg = new_keywordarg ("", yyvsp[0].expr); }
    break;
case 303:
#line 1317 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.keywordarg = new_keywordarg (yyvsp[0].string_val, 0); }
    break;
case 306:
#line 1324 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyvsp[0].keywordarg->next = yyvsp[-1].keywordarg;
			yyval.keywordarg = yyvsp[0].keywordarg;
		}
    break;
case 307:
#line 1331 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.keywordarg = new_keywordarg (yyvsp[-1].string_val, 0); }
    break;
case 308:
#line 1332 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.keywordarg = new_keywordarg ("", 0); }
    break;
case 309:
#line 1336 "../../../../tools/qfcc/source/qc-parse.y"
{ yyval.expr = new_string_expr (yyvsp[0].string_val); }
    break;
case 310:
#line 1338 "../../../../tools/qfcc/source/qc-parse.y"
{
			yyval.expr = binary_expr ('+', yyvsp[-2].expr, new_string_expr (yyvsp[0].string_val));
		}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 1343 "../../../../tools/qfcc/source/qc-parse.y"


typedef struct def_state_s {
	struct def_state_s *next;
	def_t		*def;
	int			state;
} def_state_t;

static def_state_t *free_def_states;

static const char *
ds_get_key (void *_d, void *unused)
{
	return ((def_state_t *)_d)->def->name;
}

static void
ds_free_key (void *_d, void *unused)
{
	def_state_t *d = (def_state_t *)_d;
	d->next = free_def_states;
	free_def_states = d;
}

static void
scan_scope (hashtab_t *tab, scope_t *scope)
{
	def_t      *def;
	if (scope->type == sc_local)
		scan_scope (tab, scope->parent);
	for (def = scope->head; def; def = def->def_next) {
		if  (def->name && !def->removed) {
			def_state_t *ds;
			ALLOC (1024, def_state_t, def_states, ds);
			ds->def = def;
			ds->state = def->initialized;
			Hash_Add (tab, ds);
		}
	}
}

hashtab_t *
save_local_inits (scope_t *scope)
{
	hashtab_t  *tab = Hash_NewTable (61, ds_get_key, ds_free_key, 0);
	scan_scope (tab, scope);
	return tab;
}

hashtab_t *
merge_local_inits (hashtab_t *dl_1, hashtab_t *dl_2)
{
	hashtab_t  *tab = Hash_NewTable (61, ds_get_key, ds_free_key, 0);
	def_state_t **ds_list = (def_state_t **)Hash_GetList (dl_1);
	def_state_t **ds;
	def_state_t *d;
	def_state_t *nds;

	for (ds = ds_list; *ds; ds++) {
		d = Hash_Find (dl_2, (*ds)->def->name);
		(*ds)->def->initialized = (*ds)->state;

		ALLOC (1024, def_state_t, def_states, nds);
		nds->def = (*ds)->def;
		nds->state = (*ds)->state && d->state;
		Hash_Add (tab, nds);
	}
	free (ds_list);
	return tab;
}

void
restore_local_inits (hashtab_t *def_list)
{
	def_state_t **ds_list = (def_state_t **)Hash_GetList (def_list);
	def_state_t **ds;

	for (ds = ds_list; *ds; ds++)
		(*ds)->def->initialized = (*ds)->state;
	free (ds_list);
}

void
free_local_inits (hashtab_t *def_list)
{
	Hash_DelTable (def_list);
}

expr_t *
argc_expr (void)
{
	warning (0, "@argc deprecated: use @args.count");
	return binary_expr ('.', new_name_expr (".args"), new_name_expr ("count"));
}

expr_t *
argv_expr (void)
{
	warning (0, "@argv deprecated: use @args.list");
	return binary_expr ('.', new_name_expr (".args"), new_name_expr ("list"));
}
