#ifndef BISON_QC_PARSE_H
# define BISON_QC_PARSE_H

#ifndef YYSTYPE
typedef union {
	int			op;
	struct def_s *def;
	struct hashtab_s	*def_list;
	type_t		*type;
	expr_t		*expr;
	int			integer_val;
	float		float_val;
	const char *string_val;
	float		vector_val[3];
	float		quaternion_val[4];
	struct function_s *function;
	struct switch_block_s	*switch_block;
	struct param_s	*param;
	struct method_s	*method;
	struct class_s	*class;
	struct category_s *category;
	struct class_type_s	*class_type;
	struct protocol_s *protocol;
	struct keywordarg_s *keywordarg;
	struct methodlist_s *methodlist;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	ASX	257
# define	PAS	258
# define	OR	259
# define	AND	260
# define	EQ	261
# define	NE	262
# define	LE	263
# define	GE	264
# define	LT	265
# define	GT	266
# define	SHL	267
# define	SHR	268
# define	UNARY	269
# define	INCOP	270
# define	HYPERUNARY	271
# define	CLASS_NAME	272
# define	NAME	273
# define	STRING_VAL	274
# define	INT_VAL	275
# define	FLOAT_VAL	276
# define	VECTOR_VAL	277
# define	QUATERNION_VAL	278
# define	LOCAL	279
# define	RETURN	280
# define	WHILE	281
# define	DO	282
# define	IF	283
# define	ELSE	284
# define	FOR	285
# define	BREAK	286
# define	CONTINUE	287
# define	ELLIPSIS	288
# define	NIL	289
# define	IFBE	290
# define	IFB	291
# define	IFAE	292
# define	IFA	293
# define	SWITCH	294
# define	CASE	295
# define	DEFAULT	296
# define	STRUCT	297
# define	UNION	298
# define	ENUM	299
# define	TYPEDEF	300
# define	SUPER	301
# define	SELF	302
# define	THIS	303
# define	ARGS	304
# define	ARGC	305
# define	ARGV	306
# define	EXTERN	307
# define	STATIC	308
# define	SYSTEM	309
# define	SIZEOF	310
# define	ELE_START	311
# define	TYPE	312
# define	CLASS	313
# define	DEFS	314
# define	ENCODE	315
# define	END	316
# define	IMPLEMENTATION	317
# define	INTERFACE	318
# define	PRIVATE	319
# define	PROTECTED	320
# define	PROTOCOL	321
# define	PUBLIC	322
# define	SELECTOR	323


extern YYSTYPE yylval;

#endif /* not BISON_QC_PARSE_H */
